#include "../../BarinkEngine/src/BarinkEngine.h"
#include "../../BarinkEngine/src/Scene/Components.h"
#include "../../BarinkEngine/src/Scene/Scene.h"
#include "../../BarinkEngine/src/Scene/Entity.h"
#include <imgui.h>
#include "GUI.h"
#include "Util.h"
#include <entt/entt.hpp>
/*
* Define globals
*/
//Shader* shader;
const std::string vertexShaderSource = "build/Debug/test.vs";
const std::string fragmentShaderSource = "build/Debug/test.fs";

Scene scene;
/*
* Runs once at startup 
* - USe to initialize the game/sandbox/demo
*/
void Start() {
   // shader = new Shader(vertexShaderSource, fragmentShaderSource);
   
    auto cube  = scene.AddEntity((std::string&)"cube");
    auto transform = cube.AddComponent<BarinkEngine::TransformComponent>();
    auto render3DComponent = cube.AddComponent<BarinkEngine::Render3DComponent>();

    auto cube2 = scene.AddEntity((std::string&)"cube1");

    auto cube3 = scene.AddEntity((std::string&)"cube2");
    auto Transform2 = cube3.AddComponent<BarinkEngine::TransformComponent>();
    auto render3DComponent2 = cube3.AddComponent<BarinkEngine::Render3DComponent>();

    
    // Run over every transform component
    auto view = scene.getReg().view<BarinkEngine::TransformComponent, BarinkEngine::Render3DComponent>();
    view.each([](auto entity, auto& transform) {
        std::cout << "Found a transform !" << std::endl;
    });
    
    
}

/*
* Runs every frame
* - Use to draw Immediate mode graphics (Not meant for HUD's )
*/
void ImmediateGraphicsDraw() 
{
    // Show internal BarinkEngine stats
    ShowStats();
}

/*
* Runs every frame
* - Meant for game logic ( non-physics related) 
*/
void Update()
{
    
    renderer.Render(scene);
   
}

/*
* Runs at the end of the program
* - Meant for cleanup
*/
void Stop()
{
}